import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/radio/radio.ts
import { property, state } from "lit/decorators.js";

// libs/core/src/components/radio/radio.styles.ts
import { css } from "lit";
var styles = css`
  @layer base, a11y, reset, transitional-styles;

  @layer a11y {
    @media (prefers-reduced-motion: reduce) {
      .radio {
        transition: none;
      }
    }
  }

  @layer base {
    :host([disabled]) {
      --_radio-label-color: var(--gds-color-l3-content-disabled);
    }

    .radio {
      display: flex;
      align-items: center;
      justify-content: center;
      position: relative;
      width: var(--radio-disc-size);
      height: var(--radio-disc-size);
      margin-block-start: calc(var(--radio-border-width) * 2);
      cursor: pointer;
    }

    .state {
      display: flex;
      box-sizing: border-box;
      backface-visibility: hidden;
      transition-property: background-color, scale, outline;
      transition-duration: 248ms;
      outline-style: solid;
      outline-offset: calc(-1 * var(--radio-outline-width));
      outline-width: var(--radio-outline-width);
      outline-color: transparent;
      border-radius: var(--radio-radius);
      min-width: var(--radio-size);
      min-height: var(--radio-size);
      position: absolute;
      left: calc(* 1 - calc((var(--radio-size) - var(--radio-disc-size)) / 2));
      top: calc(* 1 - calc((var(--radio-size) - var(--radio-disc-size)) / 2));
      scale: 0.8;
    }

    @media (hover: hover) {
      .radio:hover,
      :host(:hover) .radio .state {
        background-color: var(--radio-bg-mix);
        scale: 1;
      }
    }

    .radio:active .state,
    :host(:active) .radio .state {
      background-color: var(--radio-bg-mix-active);
    }

    :host(:active:not(:focus-visible)) .radio:active .state,
    :host(:active:not(:focus-visible)) .radio .state {
      scale: 0.96;
    }

    :host(:focus) {
      outline: none;
    }

    :host(:focus) .radio .state {
      outline-color: var(--_radio-outline-color);
      scale: 1;
    }

    :host(:not(:focus-visible)) .radio .state {
      outline-color: transparent;
    }

    .disc {
      width: var(--radio-disc-size);
      height: var(--radio-disc-size);
      border-radius: var(--radio-radius);
      box-shadow: inset 0 0 0 var(--radio-border-width)
        var(--radio-border-color);
      background-color: var(--radio-disc-background-color);
      box-sizing: border-box;
      transition-property: box-shadow;
      transition-duration: 248ms;
      will-change: box-shadow;
      position: absolute;
      inset: 0;
    }

    :host([checked]) .disc,
    :host(:active) .disc {
      box-shadow: inset 0 0 0 var(--radio-border-width-selected)
        var(--radio-border-color-selected);
    }

    :host([disabled]) {
      pointer-events: none;
    }

    :host([disabled]) .radio .disc {
      box-shadow: none;
      background-color: var(--gds-color-l3-content-disabled);
    }
  }
`;

// libs/core/src/components/radio/radio.ts
var _handleClick, _handleKeyDown;
var GdsRadio = class extends GdsElement {
  constructor() {
    super();
    this.label = "";
    this.supportingText = "";
    this.value = "";
    this.checked = false;
    this.disabled = false;
    this.invalid = false;
    this._isFocused = false;
    __privateAdd(this, _handleClick, (e) => {
      if (this.disabled || !this.value || !this.label)
        return;
      e.preventDefault();
      this.checked = true;
      this.focus();
      this.dispatchEvent(new Event("gds-radio-change", { bubbles: true }));
    });
    __privateAdd(this, _handleKeyDown, (e) => {
      if (this.disabled)
        return;
      if (e.key === "Enter" || e.key === " ") {
        e.preventDefault();
        this.checked = true;
        this.dispatchEvent(new Event("gds-radio-change", { bubbles: true }));
      }
    });
    this.addEventListener("keydown", __privateGet(this, _handleKeyDown));
    this.addEventListener("focus", () => this._isFocused = true);
    this.addEventListener("blur", () => this._isFocused = false);
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "radio");
    this._updateAriaState();
    this.addEventListener("click", __privateGet(this, _handleClick));
  }
  _updateAriaState() {
    this.setAttribute("aria-checked", this.checked.toString());
    this.setAttribute("aria-disabled", this.disabled.toString());
    this.setAttribute("tabindex", this.disabled ? "-1" : "0");
    this.toggleAttribute("aria-invalid", this.invalid);
  }
  updated(changedProperties) {
    super.updated(changedProperties);
    if (changedProperties.has("checked") || changedProperties.has("disabled") || changedProperties.has("invalid")) {
      this._updateAriaState();
    }
  }
  _handleDisabledChange() {
    if (this.disabled) {
      this.setAttribute("inert", "");
    } else {
      this.removeAttribute("inert");
    }
  }
  render() {
    return html`
      <gds-selection-field-label
        supporting-text=${this.supportingText}
        label=${this.label}
        type="radio"
      >
        <div class="radio">
          <div class="state"></div>
          <div class="disc"></div>
        </div>
      </gds-selection-field-label>
    `;
  }
};
_handleClick = new WeakMap();
_handleKeyDown = new WeakMap();
GdsRadio.styles = [styles];
__decorateClass([
  property()
], GdsRadio.prototype, "label", 2);
__decorateClass([
  property({ attribute: "supporting-text" })
], GdsRadio.prototype, "supportingText", 2);
__decorateClass([
  property()
], GdsRadio.prototype, "value", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsRadio.prototype, "checked", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsRadio.prototype, "disabled", 2);
__decorateClass([
  property({ type: Boolean })
], GdsRadio.prototype, "invalid", 2);
__decorateClass([
  state()
], GdsRadio.prototype, "_isFocused", 2);
__decorateClass([
  watch("disabled")
], GdsRadio.prototype, "_handleDisabledChange", 1);
GdsRadio = __decorateClass([
  gdsCustomElement("gds-radio")
], GdsRadio);

export {
  GdsRadio
};
